Index: trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 107942)
+++ trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 107943)
@@ -636,5 +636,4 @@
 	src/manager/tools/UIToolsModel.h \
 	src/manager/tools/UIToolsView.h \
-	src/manager/tools/UIToolsHandlerMouse.h \
 	src/manager/tools/UIToolsItem.h \
 	src/medium/UIMediumDetailsWidget.h \
@@ -1169,5 +1168,4 @@
 	src/manager/tools/UIToolsModel.cpp \
 	src/manager/tools/UIToolsView.cpp \
-	src/manager/tools/UIToolsHandlerMouse.cpp \
 	src/manager/tools/UIToolsItem.cpp \
 	src/medium/UIMediumDetailsWidget.cpp \
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsHandlerMouse.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsHandlerMouse.cpp	(revision 107942)
+++ 	(revision )
@@ -1,94 +1,0 @@
-/* $Id$ */
-/** @file
- * VBox Qt GUI - UIToolsHandlerMouse class implementation.
- */
-
-/*
- * Copyright (C) 2012-2024 Oracle and/or its affiliates.
- *
- * This file is part of VirtualBox base platform packages, as
- * available from https://www.virtualbox.org.
- *
- * This program is free software; you can redistribute it and/or
- * modify it under the terms of the GNU General Public License
- * as published by the Free Software Foundation, in version 3 of the
- * License.
- *
- * This program is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, see <https://www.gnu.org/licenses>.
- *
- * SPDX-License-Identifier: GPL-3.0-only
- */
-
-/* Qt includes: */
-#include <QGraphicsSceneMouseEvent>
-
-/* GUI incluedes: */
-#include "UIToolsHandlerMouse.h"
-#include "UIToolsModel.h"
-
-
-UIToolsHandlerMouse::UIToolsHandlerMouse(UIToolsModel *pParent)
-    : QObject(pParent)
-    , m_pModel(pParent)
-{
-}
-
-bool UIToolsHandlerMouse::handle(QGraphicsSceneMouseEvent *pEvent, UIMouseEventType enmType) const
-{
-    /* Process passed event: */
-    switch (enmType)
-    {
-        case UIMouseEventType_Press:   return handleMousePress(pEvent);
-        case UIMouseEventType_Release: return handleMouseRelease(pEvent);
-    }
-    /* Pass event if unknown: */
-    return false;
-}
-
-UIToolsModel *UIToolsHandlerMouse::model() const
-{
-    return m_pModel;
-}
-
-bool UIToolsHandlerMouse::handleMousePress(QGraphicsSceneMouseEvent *pEvent) const
-{
-    /* Get item under mouse cursor: */
-    QPointF scenePos = pEvent->scenePos();
-    if (QGraphicsItem *pItemUnderMouse = model()->itemAt(scenePos))
-    {
-        /* Which button it was? */
-        switch (pEvent->button())
-        {
-            /* Both buttons: */
-            case Qt::LeftButton:
-            case Qt::RightButton:
-            {
-                /* Which item we just clicked? */
-                UIToolsItem *pClickedItem = qgraphicsitem_cast<UIToolsItem*>(pItemUnderMouse);
-                /* Make clicked item the current one: */
-                if (pClickedItem && pClickedItem->isEnabled())
-                {
-                    model()->setCurrentItem(pClickedItem);
-                    model()->close();
-                }
-                break;
-            }
-            default:
-                break;
-        }
-    }
-    /* Pass all other events: */
-    return false;
-}
-
-bool UIToolsHandlerMouse::handleMouseRelease(QGraphicsSceneMouseEvent *) const
-{
-    /* Pass all events: */
-    return false;
-}
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsHandlerMouse.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsHandlerMouse.h	(revision 107942)
+++ 	(revision )
@@ -1,79 +1,0 @@
-/* $Id$ */
-/** @file
- * VBox Qt GUI - UIToolsHandlerMouse class declaration.
- */
-
-/*
- * Copyright (C) 2012-2024 Oracle and/or its affiliates.
- *
- * This file is part of VirtualBox base platform packages, as
- * available from https://www.virtualbox.org.
- *
- * This program is free software; you can redistribute it and/or
- * modify it under the terms of the GNU General Public License
- * as published by the Free Software Foundation, in version 3 of the
- * License.
- *
- * This program is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, see <https://www.gnu.org/licenses>.
- *
- * SPDX-License-Identifier: GPL-3.0-only
- */
-
-#ifndef FEQT_INCLUDED_SRC_manager_tools_UIToolsHandlerMouse_h
-#define FEQT_INCLUDED_SRC_manager_tools_UIToolsHandlerMouse_h
-#ifndef RT_WITHOUT_PRAGMA_ONCE
-# pragma once
-#endif
-
-/* Qt includes: */
-#include <QObject>
-
-/* Forward declarations: */
-class QGraphicsSceneMouseEvent;
-class UIToolsModel;
-class UIToolsItem;
-
-
-/** Mouse event type. */
-enum UIMouseEventType
-{
-    UIMouseEventType_Press,
-    UIMouseEventType_Release
-};
-
-
-/** QObject extension used as mouse handler for graphics tools selector. */
-class UIToolsHandlerMouse : public QObject
-{
-    Q_OBJECT;
-
-public:
-
-    /** Constructs mouse handler passing @a pParent to the base-class. */
-    UIToolsHandlerMouse(UIToolsModel *pParent);
-
-    /** Handles mouse @a pEvent of certain @a enmType. */
-    bool handle(QGraphicsSceneMouseEvent *pEvent, UIMouseEventType enmType) const;
-
-private:
-
-    /** Returns the parent model reference. */
-    UIToolsModel *model() const;
-
-    /** Handles mouse press @a pEvent. */
-    bool handleMousePress(QGraphicsSceneMouseEvent *pEvent) const;
-    /** Handles mouse release @a pEvent. */
-    bool handleMouseRelease(QGraphicsSceneMouseEvent *pEvent) const;
-
-    /** Holds the parent model reference. */
-    UIToolsModel *m_pModel;
-};
-
-
-#endif /* !FEQT_INCLUDED_SRC_manager_tools_UIToolsHandlerMouse_h */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsModel.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsModel.cpp	(revision 107942)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsModel.cpp	(revision 107943)
@@ -40,5 +40,4 @@
 #include "UILoggingDefs.h"
 #include "UITools.h"
-#include "UIToolsHandlerMouse.h"
 #include "UIToolsModel.h"
 #include "UITranslationEventListener.h"
@@ -66,5 +65,4 @@
     , m_pTools(pParent)
     , m_pScene(0)
-    , m_pMouseHandler(0)
     , m_fItemsEnabled(true)
 {
@@ -400,9 +398,37 @@
         /* Mouse handler: */
         case QEvent::GraphicsSceneMousePress:
-            return m_pMouseHandler->handle(static_cast<QGraphicsSceneMouseEvent*>(pEvent), UIMouseEventType_Press);
-        case QEvent::GraphicsSceneMouseRelease:
-            return m_pMouseHandler->handle(static_cast<QGraphicsSceneMouseEvent*>(pEvent), UIMouseEventType_Release);
-        /* Shut up MSC: */
-        default: break;
+        {
+            /* Acquire event: */
+            QGraphicsSceneMouseEvent *pMouseEvent = static_cast<QGraphicsSceneMouseEvent*>(pEvent);
+            /* Get item under mouse cursor: */
+            QPointF scenePos = pMouseEvent->scenePos();
+            if (QGraphicsItem *pItemUnderMouse = itemAt(scenePos))
+            {
+                /* Which button it was? */
+                switch (pMouseEvent->button())
+                {
+                    /* Both buttons: */
+                    case Qt::LeftButton:
+                    case Qt::RightButton:
+                    {
+                        /* Which item we just clicked? */
+                        UIToolsItem *pClickedItem = qgraphicsitem_cast<UIToolsItem*>(pItemUnderMouse);
+                        /* Make clicked item the current one: */
+                        if (pClickedItem && pClickedItem->isEnabled())
+                        {
+                            setCurrentItem(pClickedItem);
+                            close();
+                            return true;
+                        }
+                        break;
+                    }
+                    default:
+                        break;
+                }
+            }
+            break;
+        }
+        default:
+            break;
     }
 
@@ -447,6 +473,4 @@
     /* Prepare items: */
     prepareItems();
-    /* Prepare handlers: */
-    prepareHandlers();
     /* Apply language settings: */
     sltRetranslateUI();
@@ -540,9 +564,4 @@
             break;
     }
-}
-
-void UIToolsModel::prepareHandlers()
-{
-    m_pMouseHandler = new UIToolsHandlerMouse(this);
 }
 
@@ -596,10 +615,4 @@
 }
 
-void UIToolsModel::cleanupHandlers()
-{
-    delete m_pMouseHandler;
-    m_pMouseHandler = 0;
-}
-
 void UIToolsModel::cleanupItems()
 {
@@ -617,6 +630,4 @@
 void UIToolsModel::cleanup()
 {
-    /* Cleanup handlers: */
-    cleanupHandlers();
     /* Cleanup items: */
     cleanupItems();
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsModel.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsModel.h	(revision 107942)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsModel.h	(revision 107943)
@@ -53,5 +53,4 @@
 class UIActionPool;
 class UITools;
-class UIToolsHandlerMouse;
 
 /** QObject extension used as VM Tools-pane model: */
@@ -228,6 +227,4 @@
         /** Prepares items. */
         void prepareItems();
-        /** Prepares handlers. */
-        void prepareHandlers();
         /** Loads settings. */
         void loadSettings();
@@ -236,6 +233,4 @@
         static void loadLastToolTypes(UIToolType &enmTypeGlobal, UIToolType &enmTypeMachine);
 
-        /** Cleanups handlers. */
-        void cleanupHandlers();
         /** Cleanups items. */
         void cleanupItems();
@@ -263,7 +258,4 @@
         QGraphicsScene *m_pScene;
 
-        /** Holds the mouse handler instance. */
-        UIToolsHandlerMouse *m_pMouseHandler;
-
         /** Holds whether items enabled. */
         bool  m_fItemsEnabled;