Index: trunk/src/VBox/Installer/win/NLS/de_DE.wxl
===================================================================
--- trunk/src/VBox/Installer/win/NLS/de_DE.wxl	(revision 108042)
+++ trunk/src/VBox/Installer/win/NLS/de_DE.wxl	(revision 108043)
@@ -68,5 +68,5 @@
     <String Id="NeedAdmin" Value="Sie benötigen Administrations-Rechte zum (De-)Installieren von [ProductName]! Das Setup wird nun beendet." />
     <String Id="NeedMSCRT" Value="Für [ProductName] muss zuerst das Microsoft Visual C++ 2019 Redistributable Package installiert werden. Bitte installieren und danach die Installation von [ProductName] wiederholen." />
-    <String Id="WrongOS" Value="[ProductName] läuft nur auf Windows XP oder höher!" />
+    <String Id="WrongOS" Value="[ProductName] läuft nur auf Windows 10 oder höher!" />
     <String Id="Only64Bit" Value="Diese Applikation läuft nur auf 64-bit Windows-Systemen. Bitte installieren Sie die 32-bit Version von [ProductName]!" />
 	<String Id="WrongPlatformArch" Value="Diese Version von [ProductName] wurde für eine andere Plattform-Architektur entwickelt und kann daher nicht installiert werden. Bitte die passende Version für [ProductName] installieren!" />
Index: trunk/src/VBox/Installer/win/NLS/el_GR.wxl
===================================================================
--- trunk/src/VBox/Installer/win/NLS/el_GR.wxl	(revision 108042)
+++ trunk/src/VBox/Installer/win/NLS/el_GR.wxl	(revision 108043)
@@ -68,6 +68,5 @@
     <String Id="NeedAdmin" Value="Πρέπει να έχετε δικαιώματα διαχειριστή για την (απ)εγκατάσταση του [ProductName]! Η εφαρμογή θα τερματιστεί τώρα." />
     <String Id="NeedMSCRT" Value="[ProductName] needs the Microsoft Visual C++ 2019 Redistributable Package being installed first. Please install and restart the installation of [ProductName]." />
-    <String Id="WrongOS" Value="Αυτή η εφαρμογή τρέχει μόνο σε Windows XP ή παραπάνω." />
-    <String Id="Only32Bit" Value="Αυτή η εφαρμογή τρέχει μόνο σε συστήματα Windows 32 bit. Εγκαταστήστε την έκδοση 64-bit του [ProductName]!" />
+    <String Id="WrongOS" Value="Αυτή η εφαρμογή τρέχει μόνο σε Windows 10 ή παραπάνω." />
     <String Id="Only64Bit" Value="Αυτή η εφαρμογή τρέχει μόνο σε συστήματα Windows 64 bit. Εγκαταστήστε την έκδοση 32-bit του [ProductName]!" />
     <String Id="SunFound" Value="Βρέθηκε μία παλιότερη εγκατάσταση του Sun VirtualBox στον υπολογιστή. Καταργήστε πρώτα την εγκατάσταση αυτού του πακέτου και μετά εγκαταστήστε το [ProductName]!" />
Index: trunk/src/VBox/Installer/win/NLS/en_US.wxl
===================================================================
--- trunk/src/VBox/Installer/win/NLS/en_US.wxl	(revision 108042)
+++ trunk/src/VBox/Installer/win/NLS/en_US.wxl	(revision 108043)
@@ -67,5 +67,5 @@
     <String Id="NeedAdmin" Value="You need to have administrator rights to (un)install [ProductName]! This setup will abort now." />
     <String Id="NeedMSCRT" Value="[ProductName] needs the Microsoft Visual C++ 2019 Redistributable Package being installed first. Please install and restart the installation of [ProductName]." />
-    <String Id="WrongOS" Value="This application only runs on Windows XP or above." />
+    <String Id="WrongOS" Value="This application only runs on Windows 10 or above." />
     <String Id="Only64Bit" Value="This application only runs on 64-bit Windows systems. Please install the 32-bit version of [ProductName]!" />
 	<String Id="WrongPlatformArch" Value="This version of [ProductName] was developed for a different platform architecture and therefore cannot be installed. Please install a matching version of [ProductName]!" />
Index: trunk/src/VBox/Installer/win/NLS/fr_FR.wxl
===================================================================
--- trunk/src/VBox/Installer/win/NLS/fr_FR.wxl	(revision 108042)
+++ trunk/src/VBox/Installer/win/NLS/fr_FR.wxl	(revision 108043)
@@ -68,5 +68,5 @@
     <String Id="NeedAdmin" Value="Vous ne pouvez pas (dés)installer [ProductName] sans droits d'administrateur! Ce programme d'installation terminera maintenant." />
     <String Id="NeedMSCRT" Value="[ProductName] needs the Microsoft Visual C++ 2019 Redistributable Package being installed first. Please install and restart the installation of [ProductName]." />
-    <String Id="WrongOS" Value="Cette application nécéssite Windows XP ou plus récent." />
+    <String Id="WrongOS" Value="Cette application nécéssite Windows 10 ou plus récent." />
     <String Id="Only64Bit" Value="Cette application ne marche que sur des systèmes Windows 64-bit. Veuillez installer la version 32-bit de [ProductName]!" />
 	<String Id="WrongPlatformArch" Value="This version of [ProductName] was developed for a different platform architecture and therefore cannot be installed. Please install a matching version of [ProductName]!" />
Index: trunk/src/VBox/Installer/win/NLS/it_IT.wxl
===================================================================
--- trunk/src/VBox/Installer/win/NLS/it_IT.wxl	(revision 108042)
+++ trunk/src/VBox/Installer/win/NLS/it_IT.wxl	(revision 108043)
@@ -61,5 +61,5 @@
     <String Id="NeedAdmin" Value="Devi avere diritti di amministrazione per (dis)installare [ProductName]! L'installazione sarà interrotta immediatamente." />
     <String Id="NeedMSCRT" Value="[ProductName] needs the Microsoft Visual C++ 2019 Redistributable Package being installed first. Please install and restart the installation of [ProductName]." />
-    <String Id="WrongOS" Value="Questa applicazione può essere eseguita solo su Windows XP o superiori." />
+    <String Id="WrongOS" Value="Questa applicazione può essere eseguita solo su Windows 10 o superiori." />
     <String Id="Only64Bit" Value="Questa applicazione può essere eseguita solo su sistemi Windows a 64 bit. Installa la versione a 32 bit di [ProductName]!" />
 	<String Id="WrongPlatformArch" Value="This version of [ProductName] was developed for a different platform architecture and therefore cannot be installed. Please install a matching version of [ProductName]!" />
Index: trunk/src/VBox/Installer/win/NLS/ru_RU.wxl
===================================================================
--- trunk/src/VBox/Installer/win/NLS/ru_RU.wxl	(revision 108042)
+++ trunk/src/VBox/Installer/win/NLS/ru_RU.wxl	(revision 108043)
@@ -68,5 +68,5 @@
     <String Id="NeedAdmin" Value="You need to have administrator rights to (un)install [ProductName]! This setup will abort now." />
     <String Id="NeedMSCRT" Value="[ProductName] needs the Microsoft Visual C++ 2019 Redistributable Package being installed first. Please install and restart the installation of [ProductName]." />
-    <String Id="WrongOS" Value="This application only runs on Windows XP or above." />
+    <String Id="WrongOS" Value="This application only runs on Windows 10 or above." />
     <String Id="Only64Bit" Value="This application only runs on 64-bit Windows systems. Please install the 32-bit version of [ProductName]!" />
 	<String Id="WrongPlatformArch" Value="This version of [ProductName] was developed for a different platform architecture and therefore cannot be installed. Please install a matching version of [ProductName]!" />
Index: trunk/src/VBox/Installer/win/NLS/tr_TR.wxl
===================================================================
--- trunk/src/VBox/Installer/win/NLS/tr_TR.wxl	(revision 108042)
+++ trunk/src/VBox/Installer/win/NLS/tr_TR.wxl	(revision 108043)
@@ -68,5 +68,5 @@
     <String Id="NeedAdmin" Value="[ProductName] uygulamasını yüklemek(kaldırmak) için yönetici haklarına sahip olmanız gerekir! Bu kur şimdi iptal edilecek." />
     <String Id="NeedMSCRT" Value="[ProductName] uygulamasının öncelikle Microsoft Visual C++ 2019 Yeniden Dağıtılabilir Paketinin yüklenmesine ihtiyacı var. Lütfen [ProductName] uygulamasının kurulumunu yeniden başlatın ve yükleyin." />
-    <String Id="WrongOS" Value="Bu uygulama yalnızca Windows XP veya üzerinde çalışır." />
+    <String Id="WrongOS" Value="Bu uygulama yalnızca Windows 10 veya üzerinde çalışır." />
     <String Id="Only64Bit" Value="Bu uygulama yalnızca 64-bit Windows sistemlerinde çalışır. Lütfen [ProductName] 32-bit sürümünü yükleyin!" />
 	<String Id="WrongPlatformArch" Value="This version of [ProductName] was developed for a different platform architecture and therefore cannot be installed. Please install a matching version of [ProductName]!" />
Index: trunk/src/VBox/Installer/win/NLS/zh_CN.wxl
===================================================================
--- trunk/src/VBox/Installer/win/NLS/zh_CN.wxl	(revision 108042)
+++ trunk/src/VBox/Installer/win/NLS/zh_CN.wxl	(revision 108043)
@@ -68,5 +68,5 @@
 <String Id="NeedAdmin" Value="需要系统管理员权限安装 （或卸载）[ProductName]！此安装程序现在将中止。" />
 <String Id="NeedMSCRT" Value="[ProductName] needs the Microsoft Visual C++ 2019 Redistributable Package being installed first. Please install and restart the installation of [ProductName]." />
-<String Id="WrongOS" Value="此应用程序只能运行在 Windows XP 或以上。" />
+<String Id="WrongOS" Value="此应用程序只能运行在 Windows 10 或以上。" />
 <String Id="Only64Bit" Value="此应用程序只能运行在 64 位 Windows 系统。 请安装 [ProductName] 的 32 位版本！" />
 <String Id="WrongPlatformArch" Value="This version of [ProductName] was developed for a different platform architecture and therefore cannot be installed. Please install a matching version of [ProductName]!" />
@@ -433,5 +433,5 @@
 <String Id="Error1925" Value="你没有权限使计算机的所有用户都完成此安装。请以系统管理员权限登录，接著再重试此安装。" />
 <String Id="Error1926" Value="不能配置文件案 '[3]' 的文件安全性。 错误：[2]。 请确认你有权限以修改此文件的安全性权限。" />
-<String Id="Error1927" Value="这台计算机并未安装 Component Services (COM+ 1.0)。这项安装需要有 Component Services 才能进行。Component Services 包含在 Windows XP 中。" />
+<String Id="Error1927" Value="这台计算机并未安装 Component Services (COM+ 1.0)。这项安装需要有 Component Services 才能进行。Component Services 包含在 Windows 10 中。" />
 <String Id="Error1928" Value="注册 COM+ 应用程序时发生错误。请联络你的支持人员以取得其它信息。" />
 <String Id="Error1929" Value="解除 COM+ 应用程序注册时发生错误。请联络你的支持人员以取得其它信息。" />
Index: trunk/src/VBox/Installer/win/NLS/zh_TW.wxl
===================================================================
--- trunk/src/VBox/Installer/win/NLS/zh_TW.wxl	(revision 108042)
+++ trunk/src/VBox/Installer/win/NLS/zh_TW.wxl	(revision 108043)
@@ -68,5 +68,5 @@
     <String Id="NeedAdmin" Value="您需要有系統管理員特殊權限以安裝 （或解除安裝）[ProductName]！此安裝程式現在將中止。" />
     <String Id="NeedMSCRT" Value="[ProductName] 需要先安裝 Microsoft Visual C++ 2019 可分發套件。 請安裝並重新啟動 [ProductName] 安裝。" />
-    <String Id="WrongOS" Value="此應用程式只能執行在 Windows XP 或以上。" />
+    <String Id="WrongOS" Value="此應用程式只能執行在 Windows 10 或以上。" />
     <String Id="Only64Bit" Value="此應用程式只能執行在 64 位元的 Windows 系統。 請安裝 [ProductName] 的 32 位元版本！" />
 	<String Id="WrongPlatformArch" Value="This version of [ProductName] was developed for a different platform architecture and therefore cannot be installed. Please install a matching version of [ProductName]!" />
@@ -433,5 +433,5 @@
     <String Id="Error1925" Value="您沒有足夠的特殊權限使電腦的所有使用者都完成此安裝。請以系統管理員權限登入，接著再重試此安裝。" />
     <String Id="Error1926" Value="無法設定檔案 '[3]' 的檔案安全性。 錯誤: [2]。 請確認您有足夠的特殊權限以修改此檔案的安全性權限。" />
-    <String Id="Error1927" Value="這台電腦並未安裝 Component Services (COM+ 1.0)。這項安裝需要有 Component Services 才能進行。Component Services 包含在 Windows XP 中。" />
+    <String Id="Error1927" Value="這台電腦並未安裝 Component Services (COM+ 1.0)。這項安裝需要有 Component Services 才能進行。Component Services 包含在 Windows 10 中。" />
     <String Id="Error1928" Value="登錄 COM+ 應用程式時發生錯誤。請聯絡您的支援人員以取得其他資訊。" />
     <String Id="Error1929" Value="解除 COM+ 應用程式登錄時發生錯誤。請聯絡您的支援人員以取得其他資訊。" />