Index: /trunk/src/libs/curl-8.11.1/config.h.darwin.amd64
===================================================================
--- /trunk/src/libs/curl-8.11.1/config.h.darwin.amd64	(revision 108051)
+++ /trunk/src/libs/curl-8.11.1/config.h.darwin.amd64	(revision 108052)
@@ -741,5 +741,5 @@
 
 /* cpu-machine-OS */
-#define OS "i386-apple-darwin10.0.0d6"
+#define CURL_OS "i386-apple-darwin10.0.0d6"
 
 /* Name of package */
@@ -910,5 +910,5 @@
 
 /* Version number of package */
-#define VERSION "7.83.1"
+#define VERSION "8.11.1"
 
 /* Define to avoid automatic inclusion of winsock.h */
Index: /trunk/src/libs/curl-8.11.1/config.h.darwin.arm64
===================================================================
--- /trunk/src/libs/curl-8.11.1/config.h.darwin.arm64	(revision 108051)
+++ /trunk/src/libs/curl-8.11.1/config.h.darwin.arm64	(revision 108052)
@@ -817,5 +817,5 @@
 
 /* cpu-machine-OS */
-#define OS "arm-apple-darwin20.1.0"
+#define CURL_OS "arm-apple-darwin20.1.0"
 
 /* Name of package */
@@ -1017,5 +1017,5 @@
 
 /* Version number of package */
-#define VERSION "7.83.1"
+#define VERSION "8.11.1"
 
 /* Define to 1 to provide own prototypes. */
Index: /trunk/src/libs/curl-8.11.1/config.h.darwin.x86
===================================================================
--- /trunk/src/libs/curl-8.11.1/config.h.darwin.x86	(revision 108051)
+++ /trunk/src/libs/curl-8.11.1/config.h.darwin.x86	(revision 108052)
@@ -741,5 +741,5 @@
 
 /* cpu-machine-OS */
-#define OS "i386-apple-darwin9.5.0"
+#define CURL_OS "i386-apple-darwin9.5.0"
 
 /* Name of package */
@@ -910,5 +910,5 @@
 
 /* Version number of package */
-#define VERSION "7.83.1"
+#define VERSION "8.11.1"
 
 /* Define to avoid automatic inclusion of winsock.h */
Index: /trunk/src/libs/curl-8.11.1/config.h.freebsd.amd64
===================================================================
--- /trunk/src/libs/curl-8.11.1/config.h.freebsd.amd64	(revision 108051)
+++ /trunk/src/libs/curl-8.11.1/config.h.freebsd.amd64	(revision 108052)
@@ -741,5 +741,5 @@
 
 /* cpu-machine-OS */
-#define OS "i386-unknown-freebsd7.0"
+#define CURL_OS "i386-unknown-freebsd7.0"
 
 /* Name of package */
@@ -910,5 +910,5 @@
 
 /* Version number of package */
-#define VERSION "7.83.1"
+#define VERSION "8.11.1"
 
 /* Define to avoid automatic inclusion of winsock.h */
Index: /trunk/src/libs/curl-8.11.1/config.h.freebsd.x86
===================================================================
--- /trunk/src/libs/curl-8.11.1/config.h.freebsd.x86	(revision 108051)
+++ /trunk/src/libs/curl-8.11.1/config.h.freebsd.x86	(revision 108052)
@@ -741,5 +741,5 @@
 
 /* cpu-machine-OS */
-#define OS "i386-unknown-freebsd7.0"
+#define CURL_OS "i386-unknown-freebsd7.0"
 
 /* Name of package */
@@ -910,5 +910,5 @@
 
 /* Version number of package */
-#define VERSION "7.83.1"
+#define VERSION "8.11.1"
 
 /* Define to avoid automatic inclusion of winsock.h */
Index: /trunk/src/libs/curl-8.11.1/config.h.linux.amd64
===================================================================
--- /trunk/src/libs/curl-8.11.1/config.h.linux.amd64	(revision 108051)
+++ /trunk/src/libs/curl-8.11.1/config.h.linux.amd64	(revision 108052)
@@ -741,5 +741,5 @@
 
 /* cpu-machine-OS */
-#define OS "x86_64-unknown-linux-gnu"
+#define CURL_OS "x86_64-unknown-linux-gnu"
 
 /* Name of package */
@@ -910,5 +910,5 @@
 
 /* Version number of package */
-#define VERSION "7.83.1"
+#define VERSION "8.11.1"
 
 /* Define to avoid automatic inclusion of winsock.h */
Index: /trunk/src/libs/curl-8.11.1/config.h.linux.arm64
===================================================================
--- /trunk/src/libs/curl-8.11.1/config.h.linux.arm64	(revision 108051)
+++ /trunk/src/libs/curl-8.11.1/config.h.linux.arm64	(revision 108052)
@@ -741,5 +741,5 @@
 
 /* cpu-machine-OS */
-#define OS "aarch64-unknown-linux-gnu"
+#define CURL_OS "aarch64-unknown-linux-gnu"
 
 /* Name of package */
@@ -910,5 +910,5 @@
 
 /* Version number of package */
-#define VERSION "7.83.1"
+#define VERSION "8.11.1"
 
 /* Define to avoid automatic inclusion of winsock.h */
Index: /trunk/src/libs/curl-8.11.1/config.h.linux.x86
===================================================================
--- /trunk/src/libs/curl-8.11.1/config.h.linux.x86	(revision 108051)
+++ /trunk/src/libs/curl-8.11.1/config.h.linux.x86	(revision 108052)
@@ -741,5 +741,5 @@
 
 /* cpu-machine-OS */
-#define OS "i686-pc-linux-gnu"
+#define CURL_OS "i686-pc-linux-gnu"
 
 /* Name of package */
@@ -910,5 +910,5 @@
 
 /* Version number of package */
-#define VERSION "7.83.1"
+#define VERSION "8.11.1"
 
 /* Define to avoid automatic inclusion of winsock.h */
Index: /trunk/src/libs/curl-8.11.1/config.h.os2.x86
===================================================================
--- /trunk/src/libs/curl-8.11.1/config.h.os2.x86	(revision 108051)
+++ /trunk/src/libs/curl-8.11.1/config.h.os2.x86	(revision 108052)
@@ -741,5 +741,5 @@
 
 /* cpu-machine-OS */
-#define OS "i386-apple-darwin10.0.0d6"
+#define CURL_OS "i386-apple-darwin10.0.0d6"
 
 /* Name of package */
@@ -910,5 +910,5 @@
 
 /* Version number of package */
-#define VERSION "7.83.1"
+#define VERSION "8.11.1"
 
 /* Define to avoid automatic inclusion of winsock.h */
Index: /trunk/src/libs/curl-8.11.1/config.h.solaris.amd64
===================================================================
--- /trunk/src/libs/curl-8.11.1/config.h.solaris.amd64	(revision 108051)
+++ /trunk/src/libs/curl-8.11.1/config.h.solaris.amd64	(revision 108052)
@@ -741,5 +741,5 @@
 
 /* cpu-machine-OS */
-#define OS "i386-pc-solaris2.10"
+#define CURL_OS "i386-pc-solaris2.10"
 
 /* Name of package */
@@ -910,5 +910,5 @@
 
 /* Version number of package */
-#define VERSION "7.83.1"
+#define VERSION "8.11.1"
 
 /* Define to avoid automatic inclusion of winsock.h */
Index: /trunk/src/libs/curl-8.11.1/config.h.solaris.sparc32
===================================================================
--- /trunk/src/libs/curl-8.11.1/config.h.solaris.sparc32	(revision 108051)
+++ /trunk/src/libs/curl-8.11.1/config.h.solaris.sparc32	(revision 108052)
@@ -741,5 +741,5 @@
 
 /* cpu-machine-OS */
-#define OS "i386-pc-solaris2.10"
+#define CURL_OS "i386-pc-solaris2.10"
 
 /* Name of package */
@@ -910,5 +910,5 @@
 
 /* Version number of package */
-#define VERSION "7.83.1"
+#define VERSION "8.11.1"
 
 /* Define to avoid automatic inclusion of winsock.h */
Index: /trunk/src/libs/curl-8.11.1/config.h.solaris.sparc64
===================================================================
--- /trunk/src/libs/curl-8.11.1/config.h.solaris.sparc64	(revision 108051)
+++ /trunk/src/libs/curl-8.11.1/config.h.solaris.sparc64	(revision 108052)
@@ -741,5 +741,5 @@
 
 /* cpu-machine-OS */
-#define OS "i386-pc-solaris2.10"
+#define CURL_OS "i386-pc-solaris2.10"
 
 /* Name of package */
@@ -910,5 +910,5 @@
 
 /* Version number of package */
-#define VERSION "7.83.1"
+#define VERSION "8.11.1"
 
 /* Define to avoid automatic inclusion of winsock.h */
Index: /trunk/src/libs/curl-8.11.1/config.h.solaris.x86
===================================================================
--- /trunk/src/libs/curl-8.11.1/config.h.solaris.x86	(revision 108051)
+++ /trunk/src/libs/curl-8.11.1/config.h.solaris.x86	(revision 108052)
@@ -741,5 +741,5 @@
 
 /* cpu-machine-OS */
-#define OS "i386-pc-solaris2.10"
+#define CURL_OS "i386-pc-solaris2.10"
 
 /* Name of package */
@@ -910,5 +910,5 @@
 
 /* Version number of package */
-#define VERSION "7.83.1"
+#define VERSION "8.11.1"
 
 /* Define to avoid automatic inclusion of winsock.h */
Index: /trunk/src/libs/curl-8.11.1/config.h.win.amd64
===================================================================
--- /trunk/src/libs/curl-8.11.1/config.h.win.amd64	(revision 108051)
+++ /trunk/src/libs/curl-8.11.1/config.h.win.amd64	(revision 108052)
@@ -544,13 +544,18 @@
 
 /* Define cpu-machine-OS */
-#undef OS
+#ifndef CURL_OS
 #if defined(_M_IX86) || defined(__i386__) /* x86 (MSVC or gcc) */
-#define OS "i386-pc-win32"
-#elif defined(_M_IA64) /* Itanium */
-#define OS "ia64-pc-win32"
-#elif defined(_M_X64) /* AMD64/EM64T - Not defined until MSVC 2005 */
-#define OS "amd64-pc-win32"
+#define CURL_OS "i386-pc-win32"
+#elif defined(_M_X64) || defined(__x86_64__) /* x86_64 (MSVC >=2005 or gcc) */
+#define CURL_OS "x86_64-pc-win32"
+#elif defined(_M_IA64) || defined(__ia64__) /* Itanium */
+#define CURL_OS "ia64-pc-win32"
+#elif defined(_M_ARM_NT) || defined(__arm__) /* ARMv7-Thumb2 (Windows RT) */
+#define CURL_OS "thumbv7a-pc-win32"
+#elif defined(_M_ARM64) || defined(__aarch64__) /* ARM64 (Windows 10) */
+#define CURL_OS "aarch64-pc-win32"
 #else
-#define OS "unknown-pc-win32"
+#define CURL_OS "unknown-pc-win32"
+#endif
 #endif
 
Index: /trunk/src/libs/curl-8.11.1/config.h.win.arm64
===================================================================
--- /trunk/src/libs/curl-8.11.1/config.h.win.arm64	(revision 108051)
+++ /trunk/src/libs/curl-8.11.1/config.h.win.arm64	(revision 108052)
@@ -544,13 +544,18 @@
 
 /* Define cpu-machine-OS */
-#undef OS
+#ifndef CURL_OS
 #if defined(_M_IX86) || defined(__i386__) /* x86 (MSVC or gcc) */
-#define OS "i386-pc-win32"
-#elif defined(_M_IA64) /* Itanium */
-#define OS "ia64-pc-win32"
-#elif defined(_M_X64) /* AMD64/EM64T - Not defined until MSVC 2005 */
-#define OS "amd64-pc-win32"
+#define CURL_OS "i386-pc-win32"
+#elif defined(_M_X64) || defined(__x86_64__) /* x86_64 (MSVC >=2005 or gcc) */
+#define CURL_OS "x86_64-pc-win32"
+#elif defined(_M_IA64) || defined(__ia64__) /* Itanium */
+#define CURL_OS "ia64-pc-win32"
+#elif defined(_M_ARM_NT) || defined(__arm__) /* ARMv7-Thumb2 (Windows RT) */
+#define CURL_OS "thumbv7a-pc-win32"
+#elif defined(_M_ARM64) || defined(__aarch64__) /* ARM64 (Windows 10) */
+#define CURL_OS "aarch64-pc-win32"
 #else
-#define OS "unknown-pc-win32"
+#define CURL_OS "unknown-pc-win32"
+#endif
 #endif
 
Index: /trunk/src/libs/curl-8.11.1/config.h.win.x86
===================================================================
--- /trunk/src/libs/curl-8.11.1/config.h.win.x86	(revision 108051)
+++ /trunk/src/libs/curl-8.11.1/config.h.win.x86	(revision 108052)
@@ -544,13 +544,18 @@
 
 /* Define cpu-machine-OS */
-#undef OS
+#ifndef CURL_OS
 #if defined(_M_IX86) || defined(__i386__) /* x86 (MSVC or gcc) */
-#define OS "i386-pc-win32"
-#elif defined(_M_IA64) /* Itanium */
-#define OS "ia64-pc-win32"
-#elif defined(_M_X64) /* AMD64/EM64T - Not defined until MSVC 2005 */
-#define OS "amd64-pc-win32"
+#define CURL_OS "i386-pc-win32"
+#elif defined(_M_X64) || defined(__x86_64__) /* x86_64 (MSVC >=2005 or gcc) */
+#define CURL_OS "x86_64-pc-win32"
+#elif defined(_M_IA64) || defined(__ia64__) /* Itanium */
+#define CURL_OS "ia64-pc-win32"
+#elif defined(_M_ARM_NT) || defined(__arm__) /* ARMv7-Thumb2 (Windows RT) */
+#define CURL_OS "thumbv7a-pc-win32"
+#elif defined(_M_ARM64) || defined(__aarch64__) /* ARM64 (Windows 10) */
+#define CURL_OS "aarch64-pc-win32"
 #else
-#define OS "unknown-pc-win32"
+#define CURL_OS "unknown-pc-win32"
+#endif
 #endif
 