Index: /trunk/src/VBox/Frontends/VirtualBox/src/converter/UIConverterBackendGlobal.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/converter/UIConverterBackendGlobal.cpp	(revision 108082)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/converter/UIConverterBackendGlobal.cpp	(revision 108083)
@@ -1647,5 +1647,5 @@
     switch (enmToolType)
     {
-        case UIToolType_Welcome:      strResult = "Welcome"; break;
+        case UIToolType_Home:         strResult = "Home"; break;
         case UIToolType_Extensions:   strResult = "Extensions"; break;
         case UIToolType_Media:        strResult = "Media"; break;
@@ -1672,6 +1672,6 @@
 template<> SHARED_LIBRARY_STUFF UIToolType UIConverter::fromInternalString<UIToolType>(const QString &strToolType) const
 {
-    if (strToolType.compare("Welcome", Qt::CaseInsensitive) == 0)
-        return UIToolType_Welcome;
+    if (strToolType.compare("Home", Qt::CaseInsensitive) == 0)
+        return UIToolType_Home;
     if (strToolType.compare("Extensions", Qt::CaseInsensitive) == 0)
         return UIToolType_Extensions;
Index: /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp	(revision 108082)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp	(revision 108083)
@@ -290,5 +290,5 @@
             switch (enmType)
             {
-                case UIToolType_Welcome:
+                case UIToolType_Home:
                 case UIToolType_Extensions:
                 case UIToolType_Media:
Index: /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h	(revision 108082)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h	(revision 108083)
@@ -949,5 +949,5 @@
     UIToolType_Invalid,
     /* Global types: */
-    UIToolType_Welcome,
+    UIToolType_Home,
     UIToolType_Extensions,
     UIToolType_Media,
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPoolManager.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPoolManager.cpp	(revision 108082)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPoolManager.cpp	(revision 108083)
@@ -172,5 +172,5 @@
 };
 
-/** Simple action extension, used as 'Show Welcome Screen' action class. */
+/** Simple action extension, used as 'Show Home Screen' action class. */
 class UIActionToggleManagerToolsGlobalShowWelcomeScreen : public UIActionToggle
 {
@@ -183,5 +183,5 @@
         : UIActionToggle(pParent)
     {
-        setProperty("UIToolType", QVariant::fromValue(UIToolType_Welcome));
+        setProperty("UIToolType", QVariant::fromValue(UIToolType_Home));
         /// @todo use icons with check-boxes
         setIcon(UIIconPool::iconSetFull(":/welcome_screen_24px.png", ":/welcome_screen_24px.png",
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIGlobalToolsManagerWidget.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIGlobalToolsManagerWidget.cpp	(revision 108082)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIGlobalToolsManagerWidget.cpp	(revision 108083)
@@ -317,5 +317,5 @@
                         << UIToolType_Network;
     if (restrictedTypes.contains(toolMenu()->toolsType()))
-        setMenuToolType(UIToolType_Welcome);
+        setMenuToolType(UIToolType_Home);
     const QList restrictions(restrictedTypes.begin(), restrictedTypes.end());
     toolMenu()->setRestrictedToolTypes(restrictions);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.cpp	(revision 108082)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.cpp	(revision 108083)
@@ -121,12 +121,12 @@
         switch (enmType)
         {
-            case UIToolType_Welcome:
-            {
-                /* Create Desktop pane: */
+            case UIToolType_Home:
+            {
+                /* Create Welcome pane: */
                 m_pPaneWelcome = new UIWelcomePane;
                 AssertPtrReturnVoid(m_pPaneWelcome);
                 {
                     /* Configure pane: */
-                    m_pPaneWelcome->setProperty("ToolType", QVariant::fromValue(UIToolType_Welcome));
+                    m_pPaneWelcome->setProperty("ToolType", QVariant::fromValue(UIToolType_Home));
 
                     /* Add into layout: */
@@ -283,5 +283,5 @@
         switch (enmType)
         {
-            case UIToolType_Welcome:    m_pPaneWelcome = 0; break;
+            case UIToolType_Home:       m_pPaneWelcome = 0; break;
             case UIToolType_Extensions: m_pPaneExtensions = 0; break;
             case UIToolType_Media:      m_pPaneMedia = 0; break;
@@ -309,5 +309,5 @@
     switch (currentTool())
     {
-        case UIToolType_Welcome:
+        case UIToolType_Home:
             pCurrentToolWidget = m_pPaneWelcome;
             break;
@@ -363,6 +363,6 @@
     m_pLayout = new QStackedLayout(this);
 
-    /* Create desktop pane: */
-    openTool(UIToolType_Welcome);
+    /* Create welcome pane: */
+    openTool(UIToolType_Home);
 #ifdef VBOX_GUI_WITH_ADVANCED_WIDGETS
     /* Create machines pane: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp	(revision 108082)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp	(revision 108083)
@@ -1004,5 +1004,5 @@
     if (m_pWidget->isGlobalToolOpened(enmType))
     {
-        m_pWidget->setToolsTypeGlobal(UIToolType_Welcome);
+        m_pWidget->setToolsTypeGlobal(UIToolType_Home);
         m_pWidget->closeGlobalTool(enmType);
     }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerAdvancedWidget.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerAdvancedWidget.cpp	(revision 108082)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerAdvancedWidget.cpp	(revision 108083)
@@ -494,5 +494,5 @@
     switch (globalToolManager()->toolType())
     {
-        case UIToolType_Welcome:
+        case UIToolType_Home:
         {
             m_pToolBar->addAction(actionPool()->action(UIActionIndex_M_Application_S_Preferences));
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp	(revision 108082)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp	(revision 108083)
@@ -919,5 +919,5 @@
         switch (currentGlobalTool())
         {
-            case UIToolType_Welcome:
+            case UIToolType_Home:
             {
                 m_pToolBar->addAction(actionPool()->action(UIActionIndex_M_Application_S_Preferences));
@@ -1193,5 +1193,5 @@
                         << UIToolType_Network;
     if (restrictedTypes.contains(m_pMenuToolsGlobal->toolsType()))
-        m_pMenuToolsGlobal->setToolsType(UIToolType_Welcome);
+        m_pMenuToolsGlobal->setToolsType(UIToolType_Home);
     const QList restrictions(restrictedTypes.begin(), restrictedTypes.end());
     m_pMenuToolsGlobal->setRestrictedToolTypes(restrictions);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsModel.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsModel.cpp	(revision 108082)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsModel.cpp	(revision 108083)
@@ -223,7 +223,7 @@
 
     /* Adjust corrresponding actions finally: */
-    const UIToolType enmType = currentItem() ? currentItem()->itemType() : UIToolType_Welcome;
+    const UIToolType enmType = currentItem() ? currentItem()->itemType() : UIToolType_Home;
     QMap<UIToolType, UIAction*> actions;
-    actions[UIToolType_Welcome] = actionPool()->action(UIActionIndexMN_M_File_M_Tools_T_WelcomeScreen);
+    actions[UIToolType_Home] = actionPool()->action(UIActionIndexMN_M_File_M_Tools_T_WelcomeScreen);
     actions[UIToolType_Extensions] = actionPool()->action(UIActionIndexMN_M_File_M_Tools_T_ExtensionPackManager);
     actions[UIToolType_Media] = actionPool()->action(UIActionIndexMN_M_File_M_Tools_T_VirtualMediaManager);
@@ -355,5 +355,5 @@
         /* In widget mode we should add spacing after Welcome item: */
         if (   !tools()->isPopup()
-            && enmLastType == UIToolType_Welcome)
+            && enmLastType == UIToolType_Home)
             iVerticalIndent += iMajorSpacing;
 
@@ -452,5 +452,5 @@
                                     switch (pClickedItem->itemType())
                                     {
-                                        case UIToolType_Welcome:
+                                        case UIToolType_Home:
                                         {
                                             /* Toggle the button: */
@@ -513,5 +513,5 @@
         switch (pItem->itemType())
         {
-            case UIToolType_Welcome:     pItem->setName(tr("Welcome")); break;
+            case UIToolType_Home:        pItem->setName(tr("Home")); break;
             case UIToolType_Extensions:  pItem->setName(tr("Extensions")); break;
             case UIToolType_Media:       pItem->setName(tr("Media")); break;
@@ -557,34 +557,9 @@
         case UIToolClass_Global:
         {
-            /* Welcome: */
+            /* Home: */
             m_items << new UIToolsItem(scene(), UIIconPool::iconSet(":/welcome_screen_24px.png",
                                                                     ":/welcome_screen_24px.png"),
-                                       UIToolClass_Global, UIToolType_Welcome,
+                                       UIToolClass_Global, UIToolType_Home,
                                        !tools()->isPopup() /* extra-button */);
-
-            /* Extensions: */
-            m_items << new UIToolsItem(scene(), UIIconPool::iconSet(":/extension_pack_manager_24px.png",
-                                                                    ":/extension_pack_manager_disabled_24px.png"),
-                                       UIToolClass_Global, UIToolType_Extensions);
-
-            /* Media: */
-            m_items << new UIToolsItem(scene(), UIIconPool::iconSet(":/media_manager_24px.png",
-                                                                    ":/media_manager_disabled_24px.png"),
-                                       UIToolClass_Global, UIToolType_Media);
-
-            /* Network: */
-            m_items << new UIToolsItem(scene(), UIIconPool::iconSet(":/host_iface_manager_24px.png",
-                                                                    ":/host_iface_manager_disabled_24px.png"),
-                                       UIToolClass_Global, UIToolType_Network);
-
-            /* Cloud: */
-            m_items << new UIToolsItem(scene(), UIIconPool::iconSet(":/cloud_profile_manager_24px.png",
-                                                                    ":/cloud_profile_manager_disabled_24px.png"),
-                                       UIToolClass_Global, UIToolType_Cloud);
-
-            /* Activities: */
-            m_items << new UIToolsItem(scene(), UIIconPool::iconSet(":/resources_monitor_24px.png",
-                                                                    ":/resources_monitor_disabled_24px.png"),
-                                       UIToolClass_Global, UIToolType_Activities);
 
 #ifdef VBOX_GUI_WITH_ADVANCED_WIDGETS
@@ -594,4 +569,29 @@
                                        UIToolClass_Global, UIToolType_Machines);
 #endif
+
+            /* Extensions: */
+            m_items << new UIToolsItem(scene(), UIIconPool::iconSet(":/extension_pack_manager_24px.png",
+                                                                    ":/extension_pack_manager_disabled_24px.png"),
+                                       UIToolClass_Global, UIToolType_Extensions);
+
+            /* Media: */
+            m_items << new UIToolsItem(scene(), UIIconPool::iconSet(":/media_manager_24px.png",
+                                                                    ":/media_manager_disabled_24px.png"),
+                                       UIToolClass_Global, UIToolType_Media);
+
+            /* Network: */
+            m_items << new UIToolsItem(scene(), UIIconPool::iconSet(":/host_iface_manager_24px.png",
+                                                                    ":/host_iface_manager_disabled_24px.png"),
+                                       UIToolClass_Global, UIToolType_Network);
+
+            /* Cloud: */
+            m_items << new UIToolsItem(scene(), UIIconPool::iconSet(":/cloud_profile_manager_24px.png",
+                                                                    ":/cloud_profile_manager_disabled_24px.png"),
+                                       UIToolClass_Global, UIToolType_Cloud);
+
+            /* Activities: */
+            m_items << new UIToolsItem(scene(), UIIconPool::iconSet(":/resources_monitor_24px.png",
+                                                                    ":/resources_monitor_disabled_24px.png"),
+                                       UIToolClass_Global, UIToolType_Activities);
 
             break;
@@ -663,5 +663,5 @@
                     pCurrentItem = pItem;
             if (!pCurrentItem)
-                pCurrentItem = item(UIToolType_Welcome);
+                pCurrentItem = item(UIToolType_Home);
             break;
         }
@@ -688,5 +688,5 @@
     enmTypeGlobal = data.value(0);
     if (!UIToolStuff::isTypeOfClass(enmTypeGlobal, UIToolClass_Global))
-        enmTypeGlobal = UIToolType_Welcome;
+        enmTypeGlobal = UIToolType_Home;
     enmTypeMachine = data.value(1);
     if (!UIToolStuff::isTypeOfClass(enmTypeMachine, UIToolClass_Machine))