Index: trunk/include/iprt/acpi.h
===================================================================
--- trunk/include/iprt/acpi.h	(revision 108094)
+++ trunk/include/iprt/acpi.h	(revision 108095)
@@ -480,5 +480,13 @@
     kAcpiStmt_DerefOf,
     /** Store(SuperName, TermArg => Integer) statement. */
-    kAcpiStmt_Notify
+    kAcpiStmt_Notify,
+    /** SizeOf(SuperName) statement. */
+    kAcpiStmt_SizeOf,
+    /** Increment(TermArg) statement. */
+    kAcpiStmt_Increment,
+    /** Decrement(TermArg) statement. */
+    kAcpiStmt_Decrement,
+    /** CondRefOf(TermArg, Target) statement. */
+    kAcpiStmt_CondRefOf,
 } RTACPISTMT;
 
@@ -528,4 +536,22 @@
  */
 RTDECL(int) RTAcpiTblElseFinalize(RTACPITBL hAcpiTbl);
+
+
+/**
+ * Starts a new While statement operation.
+ *
+ * @returns IPRT status code.
+ * @param   hAcpiTbl            The ACPI table handle.
+ */
+RTDECL(int) RTAcpiTblWhileStart(RTACPITBL hAcpiTbl);
+
+
+/**
+ * Finalizes the current While statement operation.
+ *
+ * @returns IPRT status code.
+ * @param   hAcpiTbl            The ACPI table handle.
+ */
+RTDECL(int) RTAcpiTblWhileFinalize(RTACPITBL hAcpiTbl);
 
 
Index: trunk/include/iprt/mangling.h
===================================================================
--- trunk/include/iprt/mangling.h	(revision 108094)
+++ trunk/include/iprt/mangling.h	(revision 108095)
@@ -434,4 +434,6 @@
 # define RTAcpiTblUuidAppend                            RT_MANGLER(RTAcpiTblUuidAppend)
 # define RTAcpiTblUuidAppendFromStr                     RT_MANGLER(RTAcpiTblUuidAppendFromStr)
+# define RTAcpiTblWhileFinalize                         RT_MANGLER(RTAcpiTblWhileFinalize)
+# define RTAcpiTblWhileStart                            RT_MANGLER(RTAcpiTblWhileStart)
 # define RTArchValToString                              RT_MANGLER(RTArchValToString)
 # define RTAssertAreQuiet                               RT_MANGLER(RTAssertAreQuiet)
Index: trunk/src/VBox/Runtime/common/acpi/acpi-ast.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/acpi/acpi-ast.cpp	(revision 108094)
+++ trunk/src/VBox/Runtime/common/acpi/acpi-ast.cpp	(revision 108095)
@@ -332,4 +332,24 @@
             break;
         }
+        case kAcpiAstNodeOp_While:
+        {
+            AssertBreakStmt(   pAstNd->cArgs == 1
+                            && pAstNd->aArgs[0].enmType == kAcpiAstArgType_AstNode,
+                            rc = VERR_INTERNAL_ERROR);
+            rc = RTAcpiTblWhileStart(hAcpiTbl);
+            if (RT_SUCCESS(rc))
+            {
+                /* Predicate. */
+                rc = rtAcpiAstDumpToTbl(pAstNd->aArgs[0].u.pAstNd, hAcpiTbl);
+                if (RT_SUCCESS(rc))
+                {
+                    /* Walk all the other AST nodes. */
+                    rc = rtAcpiAstDumpAstList(&pAstNd->LstScopeNodes, hAcpiTbl);
+                    if (RT_SUCCESS(rc))
+                        rc = RTAcpiTblWhileFinalize(hAcpiTbl);
+                }
+            }
+            break;
+        }
         case kAcpiAstNodeOp_LAnd:
         case kAcpiAstNodeOp_LEqual:
@@ -591,9 +611,26 @@
         }
         case kAcpiAstNodeOp_DerefOf:
+        case kAcpiAstNodeOp_SizeOf:
+        case kAcpiAstNodeOp_Increment:
+        case kAcpiAstNodeOp_Decrement:
         {
             AssertBreakStmt(   pAstNd->cArgs == 1
                             && pAstNd->aArgs[0].enmType == kAcpiAstArgType_AstNode,
                             rc = VERR_INTERNAL_ERROR);
-            rc = RTAcpiTblStmtSimpleAppend(hAcpiTbl, kAcpiStmt_DerefOf);
+
+            RTACPISTMT enmStmt;
+            switch (pAstNd->enmOp)
+            {
+                case kAcpiAstNodeOp_DerefOf:   enmStmt = kAcpiStmt_DerefOf;   break;
+                case kAcpiAstNodeOp_SizeOf:    enmStmt = kAcpiStmt_SizeOf;    break;
+                case kAcpiAstNodeOp_Increment: enmStmt = kAcpiStmt_Increment; break;
+                case kAcpiAstNodeOp_Decrement: enmStmt = kAcpiStmt_Decrement; break;
+                default:
+                    AssertReleaseFailed(); /* Impossible */
+                    return VERR_INTERNAL_ERROR;
+            }
+
+
+            rc = RTAcpiTblStmtSimpleAppend(hAcpiTbl, enmStmt);
             if (RT_SUCCESS(rc))
                 rc = rtAcpiAstDumpToTbl(pAstNd->aArgs[0].u.pAstNd, hAcpiTbl);
@@ -618,4 +655,5 @@
         }
         case kAcpiAstNodeOp_Not:
+        case kAcpiAstNodeOp_CondRefOf:
         {
             AssertBreakStmt(   pAstNd->cArgs == 2
@@ -623,5 +661,8 @@
                             && pAstNd->aArgs[1].enmType == kAcpiAstArgType_AstNode,
                             rc = VERR_INTERNAL_ERROR);
-            rc = RTAcpiTblStmtSimpleAppend(hAcpiTbl, kAcpiStmt_Store);
+            rc = RTAcpiTblStmtSimpleAppend(hAcpiTbl,
+                                             pAstNd->enmOp == kAcpiAstNodeOp_Not
+                                           ? kAcpiStmt_Not
+                                           : kAcpiStmt_CondRefOf);
             if (RT_SUCCESS(rc))
                 rc = rtAcpiAstDumpToTbl(pAstNd->aArgs[0].u.pAstNd, hAcpiTbl);
Index: trunk/src/VBox/Runtime/common/acpi/acpi-compiler.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/acpi/acpi-compiler.cpp	(revision 108094)
+++ trunk/src/VBox/Runtime/common/acpi/acpi-compiler.cpp	(revision 108095)
@@ -290,4 +290,10 @@
     { RT_STR_TUPLE("NOT"),                      RTSCRIPTLEXTOKTYPE_KEYWORD,    true,  kAcpiAstNodeOp_Not                               },
     { RT_STR_TUPLE("NOTIFY"),                   RTSCRIPTLEXTOKTYPE_KEYWORD,    true,  kAcpiAstNodeOp_Notify                            },
+    { RT_STR_TUPLE("SIZEOF"),                   RTSCRIPTLEXTOKTYPE_KEYWORD,    true,  kAcpiAstNodeOp_SizeOf                            },
+    { RT_STR_TUPLE("WHILE"),                    RTSCRIPTLEXTOKTYPE_KEYWORD,    true,  kAcpiAstNodeOp_While                             },
+    { RT_STR_TUPLE("INCREMENT"),                RTSCRIPTLEXTOKTYPE_KEYWORD,    true,  kAcpiAstNodeOp_Increment                         },
+    { RT_STR_TUPLE("DECREMENT"),                RTSCRIPTLEXTOKTYPE_KEYWORD,    true,  kAcpiAstNodeOp_Decrement                         },
+    { RT_STR_TUPLE("CONDREFOF"),                RTSCRIPTLEXTOKTYPE_KEYWORD,    true,  kAcpiAstNodeOp_CondRefOf                         },
+    { RT_STR_TUPLE("INDEXFIELD"),               RTSCRIPTLEXTOKTYPE_KEYWORD,    true,  kAcpiAstNodeOp_IndexField                        },
 
     /* Keywords not in the operation parser table. */
@@ -1069,14 +1075,32 @@
 
 
-static DECLCALLBACK(int) rtAcpiTblAslParseField(PRTACPIASLCU pThis, PCRTACPIASLKEYWORD pKeyword, PRTACPIASTNODE pAstNd)
+static DECLCALLBACK(int) rtAcpiTblAslParseFieldOrIndexField(PRTACPIASLCU pThis, PCRTACPIASLKEYWORD pKeyword, PRTACPIASTNODE pAstNd)
 {
     RT_NOREF(pKeyword);
 
     RTACPIASL_PARSE_PUNCTUATOR(RTACPIASLTERMINAL_PUNCTUATOR_OPEN_BRACKET, '(');
+
+    uint8_t idxArg = 0;
+
+    if (pKeyword->cArgsReq == 5)
+    {
+        /* This is an IndexField. */
+
+        /* Namestring is required. */
+        RTACPIASL_PARSE_NAME_STRING(pszNameString);
+        pAstNd->aArgs[idxArg].enmType         = kAcpiAstArgType_NameString;
+        pAstNd->aArgs[idxArg].u.pszNameString = pszNameString;
+        idxArg++;
+
+        RTACPIASL_PARSE_PUNCTUATOR(RTACPIASLTERMINAL_PUNCTUATOR_COMMA, ',');
+    }
+    else /* Field */
+        Assert(pKeyword->cArgsReq == 4);
 
     /* Namestring is required. */
     RTACPIASL_PARSE_NAME_STRING(pszNameString);
-    pAstNd->aArgs[0].enmType         = kAcpiAstArgType_NameString;
-    pAstNd->aArgs[0].u.pszNameString = pszNameString;
+    pAstNd->aArgs[idxArg].enmType         = kAcpiAstArgType_NameString;
+    pAstNd->aArgs[idxArg].u.pszNameString = pszNameString;
+    idxArg++;
 
     RTACPIASL_PARSE_PUNCTUATOR(RTACPIASLTERMINAL_PUNCTUATOR_COMMA, ',');
@@ -1084,16 +1108,17 @@
     /* Must have an access type defined. */
     RTACPIASL_PARSE_KEYWORD_LIST(enmAccessType, g_aenmAccessTypeKeywords);
-    pAstNd->aArgs[1].enmType = kAcpiAstArgType_FieldAcc;
+    pAstNd->aArgs[idxArg].enmType = kAcpiAstArgType_FieldAcc;
     switch (enmAccessType)
     {
-        case RTACPIASLTERMINAL_KEYWORD_ANY_ACC:    pAstNd->aArgs[1].u.enmFieldAcc = kAcpiFieldAcc_Any;    break;
-        case RTACPIASLTERMINAL_KEYWORD_BYTE_ACC:   pAstNd->aArgs[1].u.enmFieldAcc = kAcpiFieldAcc_Byte;   break;
-        case RTACPIASLTERMINAL_KEYWORD_WORD_ACC:   pAstNd->aArgs[1].u.enmFieldAcc = kAcpiFieldAcc_Word;   break;
-        case RTACPIASLTERMINAL_KEYWORD_DWORD_ACC:  pAstNd->aArgs[1].u.enmFieldAcc = kAcpiFieldAcc_DWord;  break;
-        case RTACPIASLTERMINAL_KEYWORD_QWORD_ACC:  pAstNd->aArgs[1].u.enmFieldAcc = kAcpiFieldAcc_QWord;  break;
-        case RTACPIASLTERMINAL_KEYWORD_BUFFER_ACC: pAstNd->aArgs[1].u.enmFieldAcc = kAcpiFieldAcc_Buffer; break;
+        case RTACPIASLTERMINAL_KEYWORD_ANY_ACC:    pAstNd->aArgs[idxArg].u.enmFieldAcc = kAcpiFieldAcc_Any;    break;
+        case RTACPIASLTERMINAL_KEYWORD_BYTE_ACC:   pAstNd->aArgs[idxArg].u.enmFieldAcc = kAcpiFieldAcc_Byte;   break;
+        case RTACPIASLTERMINAL_KEYWORD_WORD_ACC:   pAstNd->aArgs[idxArg].u.enmFieldAcc = kAcpiFieldAcc_Word;   break;
+        case RTACPIASLTERMINAL_KEYWORD_DWORD_ACC:  pAstNd->aArgs[idxArg].u.enmFieldAcc = kAcpiFieldAcc_DWord;  break;
+        case RTACPIASLTERMINAL_KEYWORD_QWORD_ACC:  pAstNd->aArgs[idxArg].u.enmFieldAcc = kAcpiFieldAcc_QWord;  break;
+        case RTACPIASLTERMINAL_KEYWORD_BUFFER_ACC: pAstNd->aArgs[idxArg].u.enmFieldAcc = kAcpiFieldAcc_Buffer; break;
         default:
             AssertFailedReturn(VERR_INTERNAL_ERROR);
     }
+    idxArg++;
 
     RTACPIASL_PARSE_PUNCTUATOR(RTACPIASLTERMINAL_PUNCTUATOR_COMMA, ',');
@@ -1101,12 +1126,13 @@
     /* Must have a lock rule defined. */
     RTACPIASL_PARSE_KEYWORD_LIST(enmLockRule, g_aenmLockRuleKeywords);
-    pAstNd->aArgs[2].enmType = kAcpiAstArgType_Bool;
+    pAstNd->aArgs[idxArg].enmType = kAcpiAstArgType_Bool;
     switch (enmLockRule)
     {
-        case RTACPIASLTERMINAL_KEYWORD_LOCK:    pAstNd->aArgs[2].u.f = true;  break;
-        case RTACPIASLTERMINAL_KEYWORD_NO_LOCK: pAstNd->aArgs[2].u.f = false; break;
+        case RTACPIASLTERMINAL_KEYWORD_LOCK:    pAstNd->aArgs[idxArg].u.f = true;  break;
+        case RTACPIASLTERMINAL_KEYWORD_NO_LOCK: pAstNd->aArgs[idxArg].u.f = false; break;
         default:
             AssertFailedReturn(VERR_INTERNAL_ERROR);
     }
+    idxArg++;
 
     RTACPIASL_PARSE_PUNCTUATOR(RTACPIASLTERMINAL_PUNCTUATOR_COMMA, ',');
@@ -1114,13 +1140,14 @@
     /* Must have an update rule defined. */
     RTACPIASL_PARSE_KEYWORD_LIST(enmUpdateRule, g_aenmUpdateRuleKeywords);
-    pAstNd->aArgs[3].enmType = kAcpiAstArgType_FieldUpdate;
+    pAstNd->aArgs[idxArg].enmType = kAcpiAstArgType_FieldUpdate;
     switch (enmUpdateRule)
     {
-        case RTACPIASLTERMINAL_KEYWORD_PRESERVE:        pAstNd->aArgs[3].u.enmFieldUpdate = kAcpiFieldUpdate_Preserve;      break;
-        case RTACPIASLTERMINAL_KEYWORD_WRITE_AS_ONES:   pAstNd->aArgs[3].u.enmFieldUpdate = kAcpiFieldUpdate_WriteAsOnes;   break;
-        case RTACPIASLTERMINAL_KEYWORD_WRITE_AS_ZEROES: pAstNd->aArgs[3].u.enmFieldUpdate = kAcpiFieldUpdate_WriteAsZeroes; break;
+        case RTACPIASLTERMINAL_KEYWORD_PRESERVE:        pAstNd->aArgs[idxArg].u.enmFieldUpdate = kAcpiFieldUpdate_Preserve;      break;
+        case RTACPIASLTERMINAL_KEYWORD_WRITE_AS_ONES:   pAstNd->aArgs[idxArg].u.enmFieldUpdate = kAcpiFieldUpdate_WriteAsOnes;   break;
+        case RTACPIASLTERMINAL_KEYWORD_WRITE_AS_ZEROES: pAstNd->aArgs[idxArg].u.enmFieldUpdate = kAcpiFieldUpdate_WriteAsZeroes; break;
         default:
             AssertFailedReturn(VERR_INTERNAL_ERROR);
     }
+    idxArg++;
 
     RTACPIASL_PARSE_PUNCTUATOR(RTACPIASLTERMINAL_PUNCTUATOR_CLOSE_BRACKET, ')');
@@ -1449,5 +1476,5 @@
     /* kAcpiAstNodeOp_LLess             */  RTACPI_ASL_KEYWORD_DEFINE_2REQ_0OPT("LLess",            RTACPI_AST_NODE_F_DEFAULT,   kAcpiAstArgType_AstNode, kAcpiAstArgType_AstNode),
     /* kAcpiAstNodeOp_LLessEqual        */  RTACPI_ASL_KEYWORD_DEFINE_2REQ_0OPT("LLessEqual",       RTACPI_AST_NODE_F_DEFAULT,   kAcpiAstArgType_AstNode, kAcpiAstArgType_AstNode),
-    /* kAcpiAstNodeOp_LNot              */  RTACPI_ASL_KEYWORD_DEFINE_2REQ_0OPT("LNot",             RTACPI_AST_NODE_F_DEFAULT,   kAcpiAstArgType_AstNode, kAcpiAstArgType_AstNode),
+    /* kAcpiAstNodeOp_LNot              */  RTACPI_ASL_KEYWORD_DEFINE_1REQ_0OPT("LNot",             RTACPI_AST_NODE_F_DEFAULT,   kAcpiAstArgType_AstNode),
     /* kAcpiAstNodeOp_LNotEqual         */  RTACPI_ASL_KEYWORD_DEFINE_2REQ_0OPT("LNotEqual",        RTACPI_AST_NODE_F_DEFAULT,   kAcpiAstArgType_AstNode, kAcpiAstArgType_AstNode),
     /* kAcpiAstNodeOp_Zero              */  RTACPI_ASL_KEYWORD_DEFINE_0REQ_0OPT("Zero",             RTACPI_AST_NODE_F_DEFAULT),
@@ -1457,5 +1484,5 @@
     /* kAcpiAstNodeOp_Unicode           */  RTACPI_ASL_KEYWORD_DEFINE_1REQ_0OPT("Unicode",          RTACPI_AST_NODE_F_DEFAULT,   kAcpiAstArgType_AstNode), /* Actually only String allowed here */
     /* kAcpiAstNodeOp_OperationRegion   */  RTACPI_ASL_KEYWORD_DEFINE_4REQ_0OPT("OperationRegion",  RTACPI_AST_NODE_F_DEFAULT,   kAcpiAstArgType_NameString, kAcpiAstArgType_RegionSpace, kAcpiAstArgType_AstNode, kAcpiAstArgType_AstNode),
-    /* kAcpiAstNodeOp_Field             */  RTACPI_ASL_KEYWORD_DEFINE_HANDLER(  "Field",            rtAcpiTblAslParseField,   4, 0, RTACPI_AST_NODE_F_DEFAULT),
+    /* kAcpiAstNodeOp_Field             */  RTACPI_ASL_KEYWORD_DEFINE_HANDLER(  "Field",            rtAcpiTblAslParseFieldOrIndexField, 4, 0, RTACPI_AST_NODE_F_DEFAULT),
     /* kAcpiAstNodeOp_Name              */  RTACPI_ASL_KEYWORD_DEFINE_2REQ_0OPT("Name",             RTACPI_AST_NODE_F_DEFAULT,   kAcpiAstArgType_NameString, kAcpiAstArgType_AstNode),
     /* kAcpiAstNodeOp_ResourceTemplate  */  RTACPI_ASL_KEYWORD_DEFINE_HANDLER(  "ResourceTemplate", rtAcpiTblAslParseResourceTemplate,  0, 0, RTACPI_AST_NODE_F_DEFAULT),
@@ -1492,5 +1519,10 @@
     /* kAcpiAstNodeOp_Not               */  RTACPI_ASL_KEYWORD_DEFINE_1REQ_1OPT("Not",              RTACPI_AST_NODE_F_DEFAULT,    kAcpiAstArgType_AstNode, kAcpiAstArgType_AstNode),
     /* kAcpiAstNodeOp_Notify            */  RTACPI_ASL_KEYWORD_DEFINE_2REQ_0OPT("Notify",           RTACPI_AST_NODE_F_DEFAULT,    kAcpiAstArgType_AstNode, kAcpiAstArgType_AstNode),
-
+    /* kAcpiAstNodeOp_SizeOf            */  RTACPI_ASL_KEYWORD_DEFINE_1REQ_0OPT("SizeOf",           RTACPI_AST_NODE_F_DEFAULT,    kAcpiAstArgType_AstNode),
+    /* kAcpiAstNodeOp_While             */  RTACPI_ASL_KEYWORD_DEFINE_1REQ_0OPT("While",            RTACPI_AST_NODE_F_NEW_SCOPE,  kAcpiAstArgType_AstNode),
+    /* kAcpiAstNodeOp_Increment         */  RTACPI_ASL_KEYWORD_DEFINE_1REQ_0OPT("Increment",        RTACPI_AST_NODE_F_DEFAULT,    kAcpiAstArgType_AstNode),
+    /* kAcpiAstNodeOp_Decrement         */  RTACPI_ASL_KEYWORD_DEFINE_1REQ_0OPT("Decrement",        RTACPI_AST_NODE_F_DEFAULT,    kAcpiAstArgType_AstNode),
+    /* kAcpiAstNodeOp_CondRefOf         */  RTACPI_ASL_KEYWORD_DEFINE_1REQ_1OPT("CondRefOf",        RTACPI_AST_NODE_F_DEFAULT,    kAcpiAstArgType_AstNode, kAcpiAstArgType_AstNode),
+    /* kAcpiAstNodeOp_IndexField        */  RTACPI_ASL_KEYWORD_DEFINE_HANDLER(  "IndexField",       rtAcpiTblAslParseFieldOrIndexField, 5, 0, RTACPI_AST_NODE_F_DEFAULT),
 };
 
Index: trunk/src/VBox/Runtime/common/acpi/acpi.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/acpi/acpi.cpp	(revision 108094)
+++ trunk/src/VBox/Runtime/common/acpi/acpi.cpp	(revision 108095)
@@ -1077,4 +1077,5 @@
 
     uint8_t bOp;
+    bool fExtOp = false;
     switch (enmStmt)
     {
@@ -1095,7 +1096,13 @@
         case kAcpiStmt_DerefOf:    bOp = ACPI_AML_BYTE_CODE_OP_DEREF_OF;    break;
         case kAcpiStmt_Notify:     bOp = ACPI_AML_BYTE_CODE_OP_NOTIFY;      break;
+        case kAcpiStmt_SizeOf:     bOp = ACPI_AML_BYTE_CODE_OP_SIZE_OF;     break;
+        case kAcpiStmt_Increment:  bOp = ACPI_AML_BYTE_CODE_OP_INCREMENT;   break;
+        case kAcpiStmt_Decrement:  bOp = ACPI_AML_BYTE_CODE_OP_INCREMENT;   break;
+        case kAcpiStmt_CondRefOf:  bOp = ACPI_AML_BYTE_CODE_EXT_OP_COND_REF_OF; fExtOp = true; break;
         default:
             AssertFailedReturn(VERR_INVALID_PARAMETER);
     }
+    if (fExtOp)
+        rtAcpiTblAppendByte(pThis, ACPI_AML_BYTE_CODE_PREFIX_EXT_OP);
     rtAcpiTblAppendByte(pThis, bOp);
     return pThis->rcErr;
@@ -1138,4 +1145,23 @@
 
     return rtAcpiTblPkgFinish(pThis, ACPI_AML_BYTE_CODE_OP_ELSE);
+}
+
+
+RTDECL(int) RTAcpiTblWhileStart(RTACPITBL hAcpiTbl)
+{
+    PRTACPITBLINT pThis = hAcpiTbl;
+    AssertPtrReturn(pThis, VERR_INVALID_HANDLE);
+
+    rtAcpiTblPkgStart(pThis, ACPI_AML_BYTE_CODE_OP_WHILE);
+    return pThis->rcErr;
+}
+
+
+RTDECL(int) RTAcpiTblWhileFinalize(RTACPITBL hAcpiTbl)
+{
+    PRTACPITBLINT pThis = hAcpiTbl;
+    AssertPtrReturn(pThis, VERR_INVALID_HANDLE);
+
+    return rtAcpiTblPkgFinish(pThis, ACPI_AML_BYTE_CODE_OP_WHILE);
 }
 
Index: trunk/src/VBox/Runtime/include/internal/acpi.h
===================================================================
--- trunk/src/VBox/Runtime/include/internal/acpi.h	(revision 108094)
+++ trunk/src/VBox/Runtime/include/internal/acpi.h	(revision 108095)
@@ -166,4 +166,10 @@
     kAcpiAstNodeOp_Not,
     kAcpiAstNodeOp_Notify,
+    kAcpiAstNodeOp_SizeOf,
+    kAcpiAstNodeOp_While,
+    kAcpiAstNodeOp_Increment,
+    kAcpiAstNodeOp_Decrement,
+    kAcpiAstNodeOp_CondRefOf,
+    kAcpiAstNodeOp_IndexField,
     kAcpiAstNodeOp_32Bit_Hack = 0x7fffffff
 } RTACPIASTNODEOP;